uses NGlob, Crt,
     NGraph, NSprite, NSprMo, NPCX;

procedure MaddWrite (S: String);
begin
  DirectVideo := FALSE;
  GoToXY (5, 25);
  TextColor (110);
  Write (S);
end;

procedure CrossWrite (S: String);
begin
  SprMoHide;
  WriteLn (S);
  SprMoShow;
end;

procedure Cross;
var
  N: Integer;
  i: Byte;
  Ch: Char;
begin
  DisplayPCX ('ILOVEU.PCX');
  SetPCXPal ('ILOVEU.PCX');
  LoadSprite (SprMo, 'MOUSE256.SPR');
  SprMoInit;
  ScrOn;
  N := 0;
  TextColor (200);
  GoToXY (1, 2);
  repeat
  Inc (N);
    case N of
       50: CrossWrite ('  *   PCX-䠩');
      100: CrossWrite ('  * ࠩ  ࠩ⮢ 誠');
      150: CrossWrite ('  * ᪨ ਬ⨢');
      200: CrossWrite ('  * ।⢠   ⨯樨');
      300: CrossWrite ('  *     ZIP-䠩');
    end;
    Wait;
  until KeyPressed or (N>500);
  if KeyPressed then Ch := ReadKey;
  if Ch = #27 then ErrMsg ('By!');
  SprMoClose;
  ScrSlowOff;
end;

procedure MaddoxGames;
var
  N: Integer;
  i, Bl1, Bl2: Byte;
  Ch: Char;
  Poi: array [1..40] of record X, Y, dX, dY : Integer end;
begin
  GetBlock (Bl1, 320, 200);
  GetBlock (Bl2, 320, 200);
  DisplayPCX ('MADGAM.PCX');
  SetPCXPal ('MADGAM.PCX');
  ScrSlowOn;
  MaddWrite (' ন 256 梥⮢.');
  CutBlockXY (Bl1, 0, 0);
  CutBlockXY (Bl2, 0, 0);
  for i:=1 to 20 do begin
    with Poi [i] do begin
      X := i*5; dX := 5;
      Y := 190-i*5; dY := -5;
    end;
    with Poi [i+20] do begin
      X := 150+i*5; dX := 5;
      Y := i*5; dY := 5;
    end;
  end;
  N := 0;
  repeat
  Inc (N);
    SetActBlock (Bl1);
    PutBlockXY (Bl2, 0, 0);
    for i:=1 to 20 do begin
      with Poi [i] do begin
        X := X + dX; if (X <= 0) or (X >= 319) then dX := -dX;
        Y := Y + dY; if (Y <= 0) or (Y >= 199) then dY := -dY;
      end;
      with Poi [i+20] do begin
        X := X + dX; if (X <= 0) or (X >= 319) then dX := -dX;
        Y := Y + dY; if (Y <= 0) or (Y >= 199) then dY := -dY;
      end;
      Line (Poi[i].X, Poi[i].Y,
            Poi[i+20].X, Poi[i+20].Y, 88+i);
    end;
    SetActBlock (VisBlock);
    PutBlockXY (Bl1, 0, 0);
  until KeyPressed or (N>300);
  if KeyPressed then Ch := ReadKey;
  if Ch = #27 then ErrMsg ('By!');
  FreeBlock (Bl1);
  FreeBlock (Bl2);
  ScrSlowOff;
end;

var
  OldMaxAvail: LongInt;

begin
  OldMaxAvail := MaxAvail;
  if not SetGraph then Exit;
  InitBlocks;
  MaddoxGames;
  Cross;
  ClsGraph;
  WriteLn (OldMaxAvail - MaxAvail);
end.