unit NAct;

interface

uses NGlob,
     Crt,
     Mouse, NSprMo;

const
{=======================   ᮡ =============================}
  aUp    =  72;
  aDown  =  80;
  aLeft  =  75;
  aRight =  77;
  aLfUp  =  71;
  aRtUp  =  73;
  aLfDn  =  79;
  aRtDn  =  81;
  aIns   =  82;
  aDel   =  83;

  aCont  =  5;
  aEsc   = 1;
  aEnter = 28;
  aSpace = 57;
  aF1    = 59;
  aF2    = 60;
  aF3    = 61;
  aF4    = 62;
  aF5    = 63;
  aF6    = 64;
  aF7    = 65;
  aF8    = 66;
  aF9    = 67;
  aF10   = 68;

  aMRel    = 98;
  aMDClick = 99;
  aMPrs    = 100;

var
  Act: array [0..aMPrs] of Byte;

procedure TakeAct;
function InpChar: Char;

implementation

procedure TakeAct;
var
  Ch: Char;
  i: Byte;
  Count, TmpX, TmpY: Integer;
  TmpDC: Byte;
begin
  for i:=1 to aMPrs do Act[i]:=0;
  if SprMoOK then begin
    for i:=0 to 2 do begin
      Count := MoPressed (i, TmpX, TmpY, TmpDC);
      if Count > 0 then begin
        Act[aMPrs] := 1;
        MoX := TmpX;
        MoY := TmpY;
        Act[aMDClick] := TmpDC;
      end;
    end;
    for i:=0 to 2 do begin
      Count := MoReleased (i, TmpX, TmpY);
      if Count > 0 then begin
        Act[aMRel] := 1;
        MoReX := TmpX;
        MoReY := TmpY;
      end;
    end;
    if (not MoBttPrs) and (Act[aMPrs]>0) then MoBttPrs := TRUE;
    if MoBttPrs and (Act[aMRel]>0) then MoBttPrs := FALSE;
  end;
  if KeyPressed then
    repeat
      Ch := ReadKey;
      case Ch of
        #0: if KeyPressed then begin
              Ch := ReadKey;
              case Ch of
                #71: Inc (Act[aLfUp]);
                #72: Inc (Act[aUp]);
                #73: Inc (Act[aRtUp]);
                #75: Inc (Act[aLeft]);
                #77: Inc (Act[aRight]);
                #79: Inc (Act[aLfDn]);
                #80: Inc (Act[aDown]);
                #81: Inc (Act[aRtDn]);
                #59: Inc (Act[aF1]);
                #60: Inc (Act[aF2]);
                #61: Inc (Act[aF3]);
                #62: Inc (Act[aF4]);
                #63: Inc (Act[aF5]);
                #64: Inc (Act[aF6]);
                #65: Inc (Act[aF7]);
                #66: Inc (Act[aF8]);
                #67: Inc (Act[aF9]);
                #68: Inc (Act[aF10]);
              end;
            end;
       ' ': Inc (Act[aSpace]);
       #27: Inc (Act[aEsc]);
       #13: Inc (Act[aEnter]);
      end;
    until not KeyPressed;
end;

function InpChar: Char;
var
  Ch: Char;
  i: Byte;
  Count, TmpX, TmpY: Integer;
  TmpDC: Byte;
begin
  for i:=1 to aMPrs do Act[i]:=0;
  if SprMoOK then begin
    for i:=1 to 3 do begin
      Count := MoPressed (i, TmpX, TmpY, TmpDC);
      if Count > 0 then begin
        Act[aMPrs] := Count;
        MoX := TmpX;
        MoY := TmpY;
        Act[aMDClick] := TmpDC;
      end;
    end;
    for i:=1 to 3 do begin
      Count := MoReleased (i, TmpX, TmpY);
      if Count > 0 then begin
        Act[aMRel] := Count;
        MoReX := TmpX;
        MoReY := TmpY;
      end;
    end;
    if (not MoBttPrs) and (Act[aMPrs]>0) then MoBttPrs := TRUE;
    if MoBttPrs and (Act[aMRel] > 0) then MoBttPrs := FALSE;
  end;
  InpChar := #0;
  if KeyPressed then
    repeat
      Ch := ReadKey;
      case Ch of
        #0: if KeyPressed then begin
              Ch := ReadKey;
              case Ch of
                #71: Inc (Act[aLfUp]);
                #72: Inc (Act[aUp]);
                #73: Inc (Act[aRtUp]);
                #75: Inc (Act[aLeft]);
                #77: Inc (Act[aRight]);
                #79: Inc (Act[aLfDn]);
                #80: Inc (Act[aDown]);
                #81: Inc (Act[aRtDn]);
                #83: Inc (Act[aDel]);
                #59: Inc (Act[aF1]);
                #60: Inc (Act[aF2]);
                #61: Inc (Act[aF3]);
                #62: Inc (Act[aF4]);
                #63: Inc (Act[aF5]);
                #64: Inc (Act[aF6]);
                #65: Inc (Act[aF7]);
                #66: Inc (Act[aF8]);
                #67: Inc (Act[aF9]);
                #68: Inc (Act[aF10]);
              end;
            end;
       ' ': begin
              Inc (Act[aSpace]);
              InpChar := ' ';
            end;
       #27: Inc (Act[aEsc]);
       #13: Inc (Act[aEnter]);
      else
        InpChar := Ch;
      end;
    until not KeyPressed;
end;

end.
